

// SYSTEM INCLUDES
/*
	#include <vector>
	#include <iostream>
*/
// PROJECT INCLUDES

//#include "Instant.h"

// LOCAL INCLUDES


// FORWARD REFERENCES

/*
*	COMMENT
*	@param
*	@return
*/

					//====== LIFECYCLE ========
					template <class U>
					SomeThing<U>::SomeThing(std::string name)
						{
							nameThing=name;
						}
			
					template <class U>
					SomeThing<U>::~SomeThing()
						{
							
							instantsVector.clear();
							nameThing.clear();
							
						}
					

					//====== OPERATIONS =======
					
					/*
					*	Add a new instant to the thing
					*	@param instant: new instant
					*/
					template <class U>
					bool SomeThing<U>::addInstant(Instant* instant)
						{
							//borrame 
							int sizeInstant=instant->getSize();
							for(int i=0;i<sizeInstant;i++)
								int j=instant->getIndexInConcept(i);
							//
							int index= hasInstant(instant);
							if(index==-1)
								this->instantsVector.push_back(instant);
							return true;
						}

					//====== INQUIRY =========
					/*
					*	Get the thing stored
					*	@return thing
					*/
					template <class U>
					U* SomeThing<U>::getThing()
						{
							return &thing;
						}
					/*
					*	Get the name of the thing
					*	@return nameThing
					*/
					template <class U>
					std::string SomeThing<U>::getName()
						{
							return nameThing;
						}
					/*
					*	Get all the instants
					*	@return instants
					*/
					template <class U>
					std::vector<Instant*>* SomeThing<U>::getInstants()
						{
							return &instantsVector;
						}
					/*
					*	Get the instant that's in the index given
					*	@param indexInstant: index of the instant that they want
					*	@return instants[instantIndex]
					*/
					template <class U>
					Instant* SomeThing<U>::getInstant(int indexInstant)
						{
							return instantsVector[indexInstant];
						}
					/*
					*	Get the number of instants that the 
					*	thng has.
					*	@return instants.size()
					*/
					template <class U>
					int  SomeThing<U>::getNumberInstants()
						{
							return this->instantsVector.size();
							
						}
					/*
					*  if this is in the instant given
					*  @param instant: instant to verified if this has it
					*  @return  0<=i<numberOfInstants if this has the instant, -1 otherwise
					*/
					template <class U>
					int SomeThing<U>::hasInstant(Instant* instant)
						{
						  int i;
						  int sizeInstants=this->getNumberInstants();
						  bool isEquals=false;	
						  for(i=0;i<sizeInstants;i++)
								{
									Instant* instanti=this->getInstant(i);
									isEquals=instanti->isEquals(instant);
									if(isEquals)
										return i;
								}
						 return -1;
						}
					//====== ACCESS ==========
					/*
					*	Set the thing
					*	@param U* thing
					*/
					template <class U>
					void SomeThing<U>::setThing(U thing)
						{
							this->thing=thing;
						}
					/*
					*	Set the name of the thing
					*	@param nameThing
					*/
					template <class U>
					void SomeThing<U>::setName(std::string name)
						{
							this->nameThing=name;
						}
					/*
					*	Set the instants of the thing
					*	@param instants
					*/
					template <class U>
					void SomeThing<U>::setInstants(std::vector<Instant*> instants)
					{
						this->instantsVector=instants;
					}
					/*
					*	Remove an instant from the thing
					*	@param indexInstant: index of the instant to be removed
					*	@return true if succesful , false otherwise
					*/
					template <class U>
					bool SomeThing<U>::removeInstant(int indexInstant)
						{
							int i;
							std::vector<Instant*>::iterator instantsIterator=this->instantsVector.begin();
							int sizeInstants=this->getNumberInstants();
							for(i=0;i<sizeInstants;i++)
								{
									if(i==indexInstant)
									{
										this->instantsVector.erase(instantsIterator);
										return true;
									}
									instantsIterator++;
								}
							return false;
						}
					/*
					*	Remove an instant from the thing
					*	@param instant: instant to be deleted
					*	@return true if succesful , false otherwise
					*/
					template <class U>
					bool SomeThing<U>::removeInstant(Instant* instant)
						{
							int index=hasInstant(instant);
							if(index!=-1)
								{
									removeInstant(index);
									return true;
								}
							return false;
						}
                  
                  
